#!/usr/bin/python
#
#

import sys
from qt import *

class TestWidget(QWidget):
    def __init__(self, *args):
        
        apply(QWidget.__init__, (self,) + args)

        self.button     = QPushButton("DelButton", self)
        self.button.resize(self.button.sizeHint())
        QObject.connect(self.button, SIGNAL("clicked()"),
                        self.slotClicked)

        pass

    def slotClicked(self):
        self.emit(PYSIGNAL("sigKillButton"), ())
        pass

class MainWindow(QMainWindow):
    
    def __init__(self, *args):

        apply(QMainWindow.__init__, (self,) + args)

        self.widget     = TestWidget(self)
        self.connect(self.widget, PYSIGNAL("sigKillButton"),
                     self.removeButton)
        pass

    def removeButton(self):
        self.removeChild(self.widget)
        del self.widget

        self.addButton  = QPushButton("Added Button", self)
        self.addButton.resize(self.addButton.sizeHint())
        self.addButton.show()
        pass

    pass # MainWindow

def main(args):
    app = QApplication(args)
    win = MainWindow()
    win.show()
    app.connect(app, SIGNAL("lastWindowClosed()"), app, SLOT("quit()"))
    app.exec_loop()
    pass

if __name__ == "__main__":
    main(sys.argv)
    pass

